//+------------------------------------------------------------------+
//|                                              History_to_file.mq4 |
//|                                                              ASL |
//|                                        http://www.listforex.info |
//+------------------------------------------------------------------+
#property copyright "ASL"
#property link      "http://www.listforex.info"

string translate_date(datetime arg)
{
string date=TimeDay(arg)+"\\"+TimeMonth(arg)+"\\"+TimeYear(arg)+" "+TimeHour(arg)+":"+TimeMinute(arg);
return (date);
}


int start()
  {
string file=StringConcatenate("Account_N_",AccountNumber(),".txt");
int handle=FileOpen(file,  FILE_CSV|FILE_WRITE, '	');
if(handle<1)
    {
     Alert("    ",file,"!");
     return(false);
    }
int i,accTotal=HistoryTotal();
FileWrite(handle, " ","",""," ","","","","","");
 

  for(i=0;i<accTotal;i++)
    {
if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
       {
        Alert("      (",GetLastError(),")");
return(false);
       }
double lots=OrderLots();
string type="?";
switch(OrderType())
  {
   case 0:
      type="Buy";
      break;
   case 1:
      type="Sell";
      break;
   case 2:
      type="BuyLimit";
      break;
   case 3:
      type="SellLimit";
      break;
   case 4:
      type="BuyStop";
      break;
   case 5:
      type="SellStop";
      break;
   case 6:
      type="/";
      lots=0;
      break;
  }

     if(OrderOpenTime()>0) FileWrite(handle,OrderTicket(),translate_date(OrderOpenTime()), translate_date(OrderCloseTime()), type,lots,OrderSymbol(), OrderProfit(), OrderSwap(), OrderComment());
    }
  FileClose(handle);
  Alert (" ",file, " !");
  return(0);
  }